TFifoFilter< T > Class Template Referenceabstract
Filtering and combining

Generic base class for out-of-core FIFO filters. More...

`#include <mia/core/fifofilter.hh>`

Inheritance diagram for TFifoFilter< T >:
[legend]

## Public Types

typedef std::shared_ptr< TFifoFilter > | Pointer
| smart pointer representing this class

## Public Member Functions

void | append_filter (Pointer last)
void | finalize ()
void | push (typename ::boost::call_traits< T >::param_type x)
| TFifoFilter (size_t width, size_t min_fill, size_t read_start)

## Protected Member Functions

size_t | get_buffer_size () const
size_t | get_end () const
size_t | get_pos () const
size_t | get_start () const

## Detailed Description

template<typename T>
class TFifoFilter< T >

Generic base class for out-of-core FIFO filters.

Base class for a First-in-first out filter that does not need the whole data to be loaded.

Definition at line 52 of file fifofilter.hh.

## Member Typedef Documentation

## Pointer

template<typename T>

typedef std::shared_ptr<TFifoFilter > TFifoFilter< T >::Pointer

smart pointer representing this class

Definition at line 57 of file fifofilter.hh.

## Constructor & Destructor Documentation

## TFifoFilter()

template<typename T>

TFifoFilter< T >::TFifoFilter | ( | size_t | width,
|  | size_t | min_fill,
|  | size_t | read_start )

Constructor

Parameters

  width | filter width
  min_fill | minimum fill of the buffer to process (usally half filter width)
  read_start | number of slices need to be pushed into the pipeline before the first results can be read from the filter

## Member Function Documentation

## append_filter()

template<typename T>

void TFifoFilter< T >::append_filter | ( | Pointer | last | ) |

Attach a filter at the end of the filter chain

## finalize()

template<typename T>

void TFifoFilter< T >::finalize | ( |  | ) |

Initiate the processing of the final slices in the pipeline

## get_buffer_size()

template<typename T>

size_t TFifoFilter< T >::get_buffer_size | ( |  | ) | const

protected

Returns
  the size of the buffer

## get_end()

template<typename T>

size_t TFifoFilter< T >::get_end | ( |  | ) | const

protected

Returns
  the start slide for filtering

## get_pos()

template<typename T>

size_t TFifoFilter< T >::get_pos | ( |  | ) | const

protected

Returns
  the current buffer fill

## get_start()

template<typename T>

size_t TFifoFilter< T >::get_start | ( |  | ) | const

protected

Returns
  the start slide for filtering

## push()

template<typename T>

void TFifoFilter< T >::push | ( | typename ::boost::call_traits< T >::param_type | x | ) |

Push a data element down the filter pipeline

Parameters

  x | data element

The documentation for this class was generated from the following file:

- fifofilter.hh